<?php
Namespace App\Controller\Admin\Maintenance;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\BinaryFileResponse;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use App\Model\Admin\HomegearBackup;
use App\Utils\Utils;

class BackupController extends Controller
{
    public function indexAction(Request $request, HomegearBackup $backup, Utils $utils)
    {
        $backup->removeOld();
        return $this->render('Admin/Maintenance/Backups/list.html.twig', array(
            'sect' => $request->attributes->get('sect'),
            'mgmt' => $utils->checkManagementRunning()
        ));
    }

    public function createAction(Request $request, HomegearBackup $backup)
    {
        $result = $backup->create();
        return new JsonResponse($result);
    }

    public function downloadAction(Request $request)
    {
        $params = $request->query->all();
        if (array_key_exists('backup', $params)) {
            $response = new BinaryFileResponse($params['backup']);
            $response->headers->set('Cache-Control', 'private');
            $response->headers->set('Content-type', 'application/octet-stream');
            $response->headers->set('Content-Disposition', 'attachment; filename="' . basename($params['backup']) . '";');
            $response->headers->set('Content-length', filesize($params['backup']));
            $response->sendHeaders();
            ob_clean();
            return $response;
        }
    }

    public function restoreAction(Request $request, HomegearBackup $backup)
    {
        $status = ['result' => 'error'];
        $file = $request->files->get('backupfile');
        if ($file !== null) {
            $status = $backup->restore($file);
        }
        return new JsonResponse($status);
    }
}